
\name{f08fa}
\alias{f08fa}

\title{f08fa: Computes all eigenvalues and, optionally, eigenvectors of a real symmetric 
matrix}

\description{
f08fa computes all the eigenvalues and, optionally, all the eigenvectors 
of a real \eqn{{n}}{n} by \eqn{{n}}{n} symmetric matrix \eqn{{A}}{A}.

}

\usage{
f08fa(jobz, uplo, a,
      n = nrow(a))
}

\arguments{

\item{jobz}{string

If \eqn{jobz=\mathtt{'N'}}{jobz='N'}, compute eigenvalues only.


}
\item{uplo}{string

If \eqn{uplo=\mathtt{'U'}}{uplo='U'}, the upper triangular part of \eqn{{A}}{A} 
is stored.


}
\item{a}{double array

The \eqn{{n}}{n} by \eqn{{n}}{n} matrix \eqn{{A}}{A}. 

See the Fortran Library documentation for a description of the storage 
layout for this array.




}
\item{n}{integer: \strong{default} = nrow(a)

\eqn{{n}}{n}, the order of the matrix \eqn{{A}}{A}.


}
}

\details{
R interface to the NAG Fortran routine F08FAF.}

\value{

\item{A}{double array

If \eqn{jobz=\mathtt{'V'}}{jobz='V'}, then if \eqn{IN=0}{IN=0}, a contains 
the orthonormal eigenvectors of the matrix \eqn{{A}}{A}.


}
\item{W}{double array

If \eqn{IN=0}{IN=0}, the eigenvalues in ascending order.


}
\item{INFO}{integer

\eqn{info = {0}}{info = 0} unless the function detects an error (see the 
Errors section in Fortran library documentation).


}
}

\references{
\url{http://www.nag.co.uk/numeric/FL/nagdoc_fl23/pdf/F08/f08faf.pdf}
}

\author{NAG}

\examples{

jobz<-'Vectors'

uplo<-'Upper'

a<-matrix(c(1,2,3,4,0,2,3,4,0,0,3,4,0,0,0,4),nrow=4,ncol=4,byrow=TRUE)



f08fa(jobz,uplo,a)

}

\keyword{math}
\concept{symmetric}
\concept{eigenvalue}
\concept{eigenvector}
