
#include <R.h>
#include <Rinternals.h>
#include "nag_rwrapper_utils.h"
#include "nagmk23.h"
#ifdef __cplusplus
extern "C" {
#endif
extern void NAG_CALL e04nfa_QPHESS(CONST Integer *N, CONST Integer *JTHCOL,
                                   CONST double H[], CONST Integer *LDH,
                                   CONST double X[], double HX[],
                                   Integer *E04NFF_IUSER,
                                   double E04NFF_RUSER[],
                                   Integer IWSAV[]);

#ifdef __cplusplus
}
#endif
int wE04NFF_handle_options(SEXP OPTLIST, Integer LWSAV_logicalArray[],
                           Integer IWSAV_integerMatrix[],
                           double RWSAV_doubleMatrix[])
;

/*Declaration of global IUSER for this routine*/
Integer E04NFF_IUSER[4];

/* Length of array to hold error messages, no checks are made to ensure this is large enough */
#define LEN_ERR_MSG 100

void E04NFA_clean_up(double *A, double *BL, double *BU, double *CVEC,
                     double *H, Integer *ISTATE, double *X, double *AX,
                     double *CLAMDA,
                     Integer *IWORK, double *WORK, Integer *LWSAV,
                     Integer *IWSAV,
                     double *RWSAV);

SEXP WE04NFF(SEXP N, SEXP NCLIN, SEXP A, SEXP BL, SEXP BU, SEXP CVEC, SEXP H,
             SEXP QPHESS, SEXP ISTATE, SEXP X, SEXP OPTLIST,
             SEXP RHO)
{
  Integer IFAIL_integer, IFAIL_EXTRACTION_integer;
  Integer E04NFF_IUSER[4];
  double  E04NFF_RUSER[1];
  SEXP    ans, names;
  Integer nadv, iflag;

  /* Initialize the option arrays */
  Integer IFAIL_initializer_integer = 1;
  char    err_msg[LEN_ERR_MSG];
  char    RNAME_char[6] = "E04NFA";
  Integer RNAME_length = 6;

/*Declare dimension variables for option initializer*/
  Integer LCWSAV_integer;
  if ((strcmp(RNAME_char,
              "E04UFF") == 0) || (strcmp(RNAME_char, "E04UFA") == 0))
    {
      LCWSAV_integer = 5;
    }
  else
    {
      LCWSAV_integer = 1;
    }

  Integer LLWSAV_integer;
  if ((strcmp(RNAME_char,
              "E04NKF") == 0) || (strcmp(RNAME_char, "E04NKA") == 0))
    {
      LLWSAV_integer = 20;
    }
  else
    {
      if ((strcmp(RNAME_char,
                  "E04UGF") == 0) || (strcmp(RNAME_char, "E04UGA") == 0))
        {
          LLWSAV_integer = 20;
        }
      else
        {
          LLWSAV_integer = 120;
        }
    }

  Integer LIWSAV_integer;
  if ((strcmp(RNAME_char,
              "E04NKF") == 0) || (strcmp(RNAME_char, "E04NKA") == 0))
    {
      LIWSAV_integer = 380;
    }
  else
    {
      if ((strcmp(RNAME_char,
                  "E04UGF") == 0) || (strcmp(RNAME_char, "E04UGA") == 0))
        {
          LIWSAV_integer = 550;
        }
      else
        {
          LIWSAV_integer = 610;
        }
    }

  Integer LRWSAV_integer;
  if ((strcmp(RNAME_char,
              "E04NKF") == 0) || (strcmp(RNAME_char, "E04NKA") == 0))
    {
      LRWSAV_integer = 285;
    }
  else
    {
      if ((strcmp(RNAME_char,
                  "E04UGF") == 0) || (strcmp(RNAME_char, "E04UGA") == 0))
        {
          LRWSAV_integer = 550;
        }
      else
        {
          LRWSAV_integer = 475;
        }
    }

/*Declare the parameters for the option initializer*/
  char    *CWSAV_charArray = 0;
  Integer *LWSAV_logicalArray = 0;
  Integer *IWSAV_integerMatrix = 0;
  double  *RWSAV_doubleMatrix = 0;
  Integer CWSAV_dim1 = LCWSAV_integer;
  if (!(CWSAV_charArray = (char *) malloc(CWSAV_dim1*80*sizeof(char))))
    {
      error("Memory allocation error for %s", "CWSAV");
    }
  Integer LWSAV_dim1 = LLWSAV_integer;
  if (!(LWSAV_logicalArray = (Integer *) malloc(LWSAV_dim1*sizeof(Integer))))
    {
      error("Memory allocation error for %s", "LWSAV");
    }
  Integer IWSAV_dim1 = LIWSAV_integer;
  if (!(IWSAV_integerMatrix = (Integer *) malloc(IWSAV_dim1*sizeof(Integer))))
    {
      error("Memory allocation error for %s", "IWSAV");
    }
  Integer RWSAV_dim1 = LRWSAV_integer;
  if (!(RWSAV_doubleMatrix = (double *) malloc(RWSAV_dim1*sizeof(double))))
    {
      error("Memory allocation error for %s", "RWSAV");
    }

  nag_initializeIntegerMatrix(IWSAV_dim1, 1, IWSAV_integerMatrix);
  nag_initializeDoubleMatrix(RWSAV_dim1, 1, RWSAV_doubleMatrix);
  e04wbf_(RNAME_char, CWSAV_charArray, &LCWSAV_integer, LWSAV_logicalArray,
          &LLWSAV_integer, IWSAV_integerMatrix, &LIWSAV_integer,
          RWSAV_doubleMatrix,
          &LRWSAV_integer, &IFAIL_initializer_integer, RNAME_length,
          80);

  if (IFAIL_initializer_integer != 0)
    {
      sprintf(err_msg, "E04WBF failed with IFAIL = %ld\n",
              (long) IFAIL_initializer_integer);
      error(err_msg);
    } /* Handle options */
  int     unit_num;

  unit_num =
    wE04NFF_handle_options(OPTLIST, LWSAV_logicalArray, IWSAV_integerMatrix,
                           RWSAV_doubleMatrix);
  if (unit_num < 0)
    {
      /* Error opening output file */
      sprintf(
        err_msg,
        "Error opening monitoring file for output, check value for `monitoring file` entry in `optlist`");
      error(err_msg);
    }
  else if (unit_num > 0)
    {
      /* We are using an output file, so need to handle the advisory channel */

      /* Remember the current value */
      iflag = 0;
      x04abf_(&iflag, &nadv);

      /* Set the advisory channel to the output file. Need to do this, otherwise E04NFF sends output to both the
         advisory channel and the output file */
      iflag = 1;
      x04abf_(&iflag, &unit_num);
    }

/*initialization for input variables*/
  int     N_integer;
  if (nag_extractInteger(N, &N_integer))
    {
      error("Integer extraction error for %s", "N");
    }
  int     NCLIN_integer;
  if (nag_extractInteger(NCLIN, &NCLIN_integer))
    {
      error("Integer extraction error for %s", "NCLIN");
    }
  double  *A_doubleMatrix = 0;
  double  *BL_doubleMatrix = 0;
  double  *BU_doubleMatrix = 0;
  double  *CVEC_doubleMatrix = 0;
  double  *H_doubleMatrix = 0;
  Integer *ISTATE_integerMatrix = 0;
  double  *X_doubleMatrix = 0;

/*initialization for dimension variables*/
  Integer LDA_integer = nrows(A);
  Integer LDH_integer = nrows(H);
  Integer LIWORK_integer = 2*N_integer+3;
  Integer LWORK_integer;
  if ((IWSAV_integerMatrix[364] < 1) || (IWSAV_integerMatrix[364] > 6) ||
      (IWSAV_integerMatrix[364] == 4) || (IWSAV_integerMatrix[364] == 6))
    {
      if ((NCLIN_integer > 0))
        {
          LWORK_integer = 2*pow(N_integer, 2)+8*N_integer+5*NCLIN_integer;
        }
      else
        {
          if ((NCLIN_integer == 0))
            {
              LWORK_integer = pow(N_integer, 2)+8*N_integer;
            }
        }
    }
  else
    {
      if ((IWSAV_integerMatrix[364] == 3) || (IWSAV_integerMatrix[364] == 5))
        {
          if ((NCLIN_integer > 0))
            {
              LWORK_integer = 2*pow(N_integer, 2)+7*N_integer+5*NCLIN_integer;
            }
          else
            {
              if ((NCLIN_integer == 0))
                {
                  LWORK_integer = pow(N_integer, 2)+7*N_integer;
                }
            }
        }
      else
        {
          if ((IWSAV_integerMatrix[364] == 2))
            {
              if ((NCLIN_integer == 0))
                {
                  LWORK_integer = 8*N_integer+1;
                }
              else
                {
                  if ((NCLIN_integer >= N_integer))
                    {
                      LWORK_integer = 2*
                                      pow(N_integer,
                                          2)+8*N_integer+5*NCLIN_integer;
                    }
                  else
                    {
                      LWORK_integer = 2*
                                      pow((NCLIN_integer+1),
                                          2)+8*N_integer+5*NCLIN_integer;
                    }
                }
            }
          else
            {
              if ((NCLIN_integer == 0))
                {
                  LWORK_integer = 7*N_integer+1;
                }
              else
                {
                  if ((NCLIN_integer >= N_integer))
                    {
                      LWORK_integer = 2*
                                      pow(N_integer,
                                          2)+7*N_integer+5*NCLIN_integer;
                    }
                  else
                    {
                      LWORK_integer = 2*
                                      pow((NCLIN_integer+1),
                                          2)+7*N_integer+5*NCLIN_integer;
                    }
                }
            }
        }
    }

/*initialization for output variables*/
  int     ITER_integer;
  double  OBJ_double;
  double  *AX_doubleMatrix = 0;
  double  *CLAMDA_doubleMatrix = 0;

/*allocation general variables*/
  Integer A_dim1 = LDA_integer;
  Integer A_dim2 = 0;
  if ((NCLIN_integer > 0))
    {
      A_dim2 = N_integer;
    }
  if ((NCLIN_integer == 0))
    {
      A_dim2 = 1;
    }
  if (!(A_doubleMatrix = (double *) malloc(A_dim1*A_dim2*sizeof(double))))
    {
      error("Memory allocation error for %s", "A");
    }
  Integer BL_dim1 = N_integer+NCLIN_integer;
  if (!(BL_doubleMatrix = (double *) malloc(BL_dim1*sizeof(double))))
    {
      error("Memory allocation error for %s", "BL");
    }
  Integer BU_dim1 = N_integer+NCLIN_integer;
  if (!(BU_doubleMatrix = (double *) malloc(BU_dim1*sizeof(double))))
    {
      error("Memory allocation error for %s", "BU");
    }
  Integer CVEC_dim1;
  if ((IWSAV_integerMatrix[364] < 1) || (IWSAV_integerMatrix[364] == 2) ||
      (IWSAV_integerMatrix[364] == 4) || (IWSAV_integerMatrix[364] == 6))
    {
      CVEC_dim1 = N_integer;
    }
  else
    {
      CVEC_dim1 = 1;
    }
  if (!(CVEC_doubleMatrix = (double *) malloc(CVEC_dim1*sizeof(double))))
    {
      error("Memory allocation error for %s", "CVEC");
    }
  Integer H_dim1 = LDH_integer;
  Integer H_dim2 = MAX(N_integer, 1);
  if (!(H_doubleMatrix = (double *) malloc(H_dim1*H_dim2*sizeof(double))))
    {
      error("Memory allocation error for %s", "H");
    }
  Integer ISTATE_dim1 = N_integer+NCLIN_integer;
  if (!(ISTATE_integerMatrix = (Integer *) malloc(ISTATE_dim1*sizeof(Integer))))
    {
      error("Memory allocation error for %s", "ISTATE");
    }
  Integer X_dim1 = N_integer;
  if (!(X_doubleMatrix = (double *) malloc(X_dim1*sizeof(double))))
    {
      error("Memory allocation error for %s", "X");
    }
  Integer AX_dim1 = MAX(1, NCLIN_integer);
  if (!(AX_doubleMatrix = (double *) malloc(AX_dim1*sizeof(double))))
    {
      error("Memory allocation error for %s", "AX");
    }
  Integer CLAMDA_dim1 = N_integer+NCLIN_integer;
  if (!(CLAMDA_doubleMatrix = (double *) malloc(CLAMDA_dim1*sizeof(double))))
    {
      error("Memory allocation error for %s", "CLAMDA");
    }

/*initialization for workspace variables*/
  Integer *IWORK_integerMatrix = 0;
  double  *WORK_doubleMatrix = 0;

/*allocation for workspace variables*/
  Integer IWORK_dim1 = LIWORK_integer;
  if (!(IWORK_integerMatrix = (Integer *) malloc(IWORK_dim1*sizeof(Integer))))
    {
      error("Memory allocation error for %s", "IWORK");
    }
  Integer WORK_dim1 = LWORK_integer;
  if (!(WORK_doubleMatrix = (double *) malloc(WORK_dim1*sizeof(double))))
    {
      error("Memory allocation error for %s", "WORK");
    }

/*allocation for dimension variables*/

/*extraction for input variables*/
  if ((IFAIL_EXTRACTION_integer =
         nag_extractDoubleMatrix(1, A_dim1, A_dim2, A, A_doubleMatrix)))
    {
      if ((IFAIL_EXTRACTION_integer == 3) || (IFAIL_EXTRACTION_integer == 4))
        {
          warning(
            "Dimensions mismatch for %s, matrix is of size %d and the expected size is %d",
            "A", nrows(A), A_dim1);
        }
      else
        {
          E04NFA_clean_up(A_doubleMatrix, BL_doubleMatrix, BU_doubleMatrix,
                          CVEC_doubleMatrix, H_doubleMatrix,
                          ISTATE_integerMatrix, X_doubleMatrix,
                          AX_doubleMatrix, CLAMDA_doubleMatrix,
                          IWORK_integerMatrix,
                          WORK_doubleMatrix, LWSAV_logicalArray,
                          IWSAV_integerMatrix,
                          RWSAV_doubleMatrix);
          error("Array extraction error for %s", "A");
        }
    }
  if ((IFAIL_EXTRACTION_integer =
         nag_extractDoubleMatrix(1, BL_dim1, 1, BL, BL_doubleMatrix)))
    {
      if ((IFAIL_EXTRACTION_integer == 3) || (IFAIL_EXTRACTION_integer == 4))
        {
          warning(
            "Dimensions mismatch for %s, matrix is of size %d and the expected size is %d",
            "BL", nrows(BL), BL_dim1);
        }
      else
        {
          E04NFA_clean_up(A_doubleMatrix, BL_doubleMatrix, BU_doubleMatrix,
                          CVEC_doubleMatrix, H_doubleMatrix,
                          ISTATE_integerMatrix, X_doubleMatrix,
                          AX_doubleMatrix, CLAMDA_doubleMatrix,
                          IWORK_integerMatrix,
                          WORK_doubleMatrix, LWSAV_logicalArray,
                          IWSAV_integerMatrix,
                          RWSAV_doubleMatrix);
          error("Array extraction error for %s", "BL");
        }
    }
  if ((IFAIL_EXTRACTION_integer =
         nag_extractDoubleMatrix(1, BU_dim1, 1, BU, BU_doubleMatrix)))
    {
      if ((IFAIL_EXTRACTION_integer == 3) || (IFAIL_EXTRACTION_integer == 4))
        {
          warning(
            "Dimensions mismatch for %s, matrix is of size %d and the expected size is %d",
            "BU", nrows(BU), BU_dim1);
        }
      else
        {
          E04NFA_clean_up(A_doubleMatrix, BL_doubleMatrix, BU_doubleMatrix,
                          CVEC_doubleMatrix, H_doubleMatrix,
                          ISTATE_integerMatrix, X_doubleMatrix,
                          AX_doubleMatrix, CLAMDA_doubleMatrix,
                          IWORK_integerMatrix,
                          WORK_doubleMatrix, LWSAV_logicalArray,
                          IWSAV_integerMatrix,
                          RWSAV_doubleMatrix);
          error("Array extraction error for %s", "BU");
        }
    }
  if ((IFAIL_EXTRACTION_integer =
         nag_extractDoubleMatrix(1, CVEC_dim1, 1, CVEC, CVEC_doubleMatrix)))
    {
      if ((IFAIL_EXTRACTION_integer == 3) || (IFAIL_EXTRACTION_integer == 4))
        {
          warning(
            "Dimensions mismatch for %s, matrix is of size %d and the expected size is %d",
            "CVEC", nrows(CVEC), CVEC_dim1);
        }
      else
        {
          E04NFA_clean_up(A_doubleMatrix, BL_doubleMatrix, BU_doubleMatrix,
                          CVEC_doubleMatrix, H_doubleMatrix,
                          ISTATE_integerMatrix, X_doubleMatrix,
                          AX_doubleMatrix, CLAMDA_doubleMatrix,
                          IWORK_integerMatrix,
                          WORK_doubleMatrix, LWSAV_logicalArray,
                          IWSAV_integerMatrix,
                          RWSAV_doubleMatrix);
          error("Array extraction error for %s", "CVEC");
        }
    }
  if ((IFAIL_EXTRACTION_integer =
         nag_extractDoubleMatrix(1, H_dim1, H_dim2, H, H_doubleMatrix)))
    {
      if ((IFAIL_EXTRACTION_integer == 3) || (IFAIL_EXTRACTION_integer == 4))
        {
          warning(
            "Dimensions mismatch for %s, matrix is of size %d and the expected size is %d",
            "H", nrows(H), H_dim1);
        }
      else
        {
          E04NFA_clean_up(A_doubleMatrix, BL_doubleMatrix, BU_doubleMatrix,
                          CVEC_doubleMatrix, H_doubleMatrix,
                          ISTATE_integerMatrix, X_doubleMatrix,
                          AX_doubleMatrix, CLAMDA_doubleMatrix,
                          IWORK_integerMatrix,
                          WORK_doubleMatrix, LWSAV_logicalArray,
                          IWSAV_integerMatrix,
                          RWSAV_doubleMatrix);
          error("Array extraction error for %s", "H");
        }
    }
  if ((IFAIL_EXTRACTION_integer =
         nag_extractIntegerMatrix(1, ISTATE_dim1, 1, ISTATE,
                                  ISTATE_integerMatrix)))
    {
      if ((IFAIL_EXTRACTION_integer == 3) || (IFAIL_EXTRACTION_integer == 4))
        {
          warning(
            "Dimensions mismatch for %s, matrix is of size %d and the expected size is %d",
            "ISTATE", nrows(ISTATE), ISTATE_dim1);
        }
      else
        {
          E04NFA_clean_up(A_doubleMatrix, BL_doubleMatrix, BU_doubleMatrix,
                          CVEC_doubleMatrix, H_doubleMatrix,
                          ISTATE_integerMatrix, X_doubleMatrix,
                          AX_doubleMatrix, CLAMDA_doubleMatrix,
                          IWORK_integerMatrix,
                          WORK_doubleMatrix, LWSAV_logicalArray,
                          IWSAV_integerMatrix,
                          RWSAV_doubleMatrix);
          error("Array extraction error for %s", "ISTATE");
        }
    }
  if ((IFAIL_EXTRACTION_integer =
         nag_extractDoubleMatrix(1, X_dim1, 1, X, X_doubleMatrix)))
    {
      if ((IFAIL_EXTRACTION_integer == 3) || (IFAIL_EXTRACTION_integer == 4))
        {
          warning(
            "Dimensions mismatch for %s, matrix is of size %d and the expected size is %d",
            "X", nrows(X), X_dim1);
        }
      else
        {
          E04NFA_clean_up(A_doubleMatrix, BL_doubleMatrix, BU_doubleMatrix,
                          CVEC_doubleMatrix, H_doubleMatrix,
                          ISTATE_integerMatrix, X_doubleMatrix,
                          AX_doubleMatrix, CLAMDA_doubleMatrix,
                          IWORK_integerMatrix,
                          WORK_doubleMatrix, LWSAV_logicalArray,
                          IWSAV_integerMatrix,
                          RWSAV_doubleMatrix);
          error("Array extraction error for %s", "X");
        }
    }

/* Perform some initial checks */
  if (!isEnvironment(RHO))
    {
      error("rho must be an environment");
    }

  /* Convert function pointer funct and rho into a couple of integers and store in IUSER */
  nag_convert_p2i(RHO, &E04NFF_IUSER[0]);
  nag_convert_p2i(QPHESS, &E04NFF_IUSER[2]);

  /* Call the NAG routine */
  IFAIL_integer = 1;
  e04nfa_(&N_integer, &NCLIN_integer, A_doubleMatrix, &LDA_integer,
          BL_doubleMatrix, BU_doubleMatrix, CVEC_doubleMatrix, H_doubleMatrix,
          &LDH_integer, e04nfa_QPHESS, ISTATE_integerMatrix, X_doubleMatrix,
          &ITER_integer, &OBJ_double, AX_doubleMatrix, CLAMDA_doubleMatrix,
          IWORK_integerMatrix, &LIWORK_integer, WORK_doubleMatrix,
          &LWORK_integer,
          E04NFF_IUSER, E04NFF_RUSER, LWSAV_logicalArray, IWSAV_integerMatrix,
          RWSAV_doubleMatrix,
          &IFAIL_integer);

  /* Close the monitoring file if one opened */

  if (unit_num > 0)
    {
      IFAIL_integer = 1;
      x04adf_(&unit_num, &IFAIL_integer);

      /* Set the advisory channel back to its previous value */
      iflag = 1;
      x04abf_(&iflag, &nadv);
    }

  /* Error returns from NAG routine */
  if (IFAIL_integer != 0)
    {
      warning(
        "ABNORMAL EXIT from NAG library routine  E04NFF, : IFAIL = %ld\n",
        (long) IFAIL_integer);
    }

/* Get the list of results */
  PROTECT(ans = allocVector(VECSXP, 7));
  SET_VECTOR_ELT(ans, 0, nag_mi2r(1, ISTATE_dim1, 1, ISTATE_integerMatrix));
  SET_VECTOR_ELT(ans, 1, nag_md2r(1, X_dim1, 1, X_doubleMatrix));
  SET_VECTOR_ELT(ans, 2, nag_i2r(1, &ITER_integer));
  SET_VECTOR_ELT(ans, 3, nag_d2r(1, &OBJ_double));
  SET_VECTOR_ELT(ans, 4, nag_md2r(1, AX_dim1, 1, AX_doubleMatrix));
  SET_VECTOR_ELT(ans, 5, nag_md2r(1, CLAMDA_dim1, 1, CLAMDA_doubleMatrix));
  SET_VECTOR_ELT(ans, 6, nag_i2r(1, &IFAIL_integer));
  /* Get names for the list of results */
  PROTECT(names = allocVector(STRSXP, 7));
  SET_STRING_ELT(names, 0, mkChar("ISTATE"));
  SET_STRING_ELT(names, 1, mkChar("X"));
  SET_STRING_ELT(names, 2, mkChar("ITER"));
  SET_STRING_ELT(names, 3, mkChar("OBJ"));
  SET_STRING_ELT(names, 4, mkChar("AX"));
  SET_STRING_ELT(names, 5, mkChar("CLAMDA"));
  SET_STRING_ELT(names, 6, mkChar("IFAIL"));
  setAttrib(ans, R_NamesSymbol, names);
/* Unprotect the ans and names objects */
  UNPROTECT(2);

/*Call the clean-up routine*/
  E04NFA_clean_up(A_doubleMatrix, BL_doubleMatrix, BU_doubleMatrix,
                  CVEC_doubleMatrix, H_doubleMatrix, ISTATE_integerMatrix,
                  X_doubleMatrix,
                  AX_doubleMatrix, CLAMDA_doubleMatrix, IWORK_integerMatrix,
                  WORK_doubleMatrix,
                  LWSAV_logicalArray, IWSAV_integerMatrix,
                  RWSAV_doubleMatrix);

  return(ans);
}

void NAG_CALL e04nfa_QPHESS(CONST Integer *N, CONST Integer *JTHCOL,
                            CONST double H[], CONST Integer *LDH,
                            CONST double X[], double HX[],
                            Integer *E04NFF_IUSER, double E04NFF_RUSER[],
                            Integer IWSAV[])
{
  SEXP funct, rho, R_fcall, result;
/* Get the pointer to the R environment */
  nag_convert_i2p(&E04NFF_IUSER[0], &rho); /* Get the pointer to the R function */
  nag_convert_i2p(&E04NFF_IUSER[2], &funct);

/* Give the arguments to the function */
  PROTECT(R_fcall = lang6(
            funct,
            nag_fi2r(1, N),
            nag_fi2r(1, JTHCOL),
            nag_md2r(1, *LDH, *LDH, H),
            nag_md2r(1, *N, 1, X),
            nag_fi2r(610, IWSAV)));

/* Get the results from evaluating the function in R */
  PROTECT(result = eval(R_fcall, rho));
/* put the results returned by function into C variables */
  (void) nag_getDoubleMatrixFromList("HX", 1, *N, 1, result, HX);
  (void) nag_getIntegerMatrixFromList("IWSAV", 1, 610, 1, result, IWSAV);

/* Release R_fcall */
  UNPROTECT(2);
}

int wE04NFF_handle_options(SEXP OPTLIST, Integer LWSAV_logicalArray[],
                           Integer IWSAV_integerMatrix[],
                           double RWSAV_doubleMatrix[])
{
  SEXP       names, tentry;
  char       err_msg[LEN_ERR_MSG];
  int        i, ival;
  Integer    INFORM_setter_integer, STR_length;
  double     dval;
  const char *this_name;
  char       STR_char[100];
  int        unit_num = 0, mode = 1;

  /* No options specified */
  if (!isNewList(OPTLIST))
    {
      return 0;
    }

  /* Get the list of names from the list */
  PROTECT(names = getAttrib(OPTLIST, R_NamesSymbol));
  for (i = 0; i < length(OPTLIST); i++)
    {
      this_name = CHAR(STRING_ELT(names, i));

      /* Only interested in the first element, which is what asReal should
         convert to a double */
      PROTECT(tentry = VECTOR_ELT(OPTLIST, i));
      if (!isString(tentry))
        {
          dval = asReal(tentry);
          if (!R_FINITE(dval)) dval = 0.0;
          ival = (int) dval;
        }
      else
        {
          dval = -1.0;
          ival = -1;
        }

      STR_char[0] = '\0';
      if (!strcmp(this_name, "list"))
        {
          if (ival)
            {
              sprintf(STR_char, "list");
            }
          else
            {
              sprintf(STR_char, "nolist");
            }
        }
      else if (!strcmp(this_name, "Check Frequency"))
        {
          sprintf(STR_char, "Check Frequency = %g", dval);
        }
      else if (!strcmp(this_name, "Crash Tolerance"))
        {
          sprintf(STR_char, "Crash Tolerance = %g", dval);
        }
      else if (!strcmp(this_name, "Expand Frequency"))
        {
          sprintf(STR_char, "Expand Frequency = %d", ival);
        }
      else if (!strcmp(this_name, "Feasibility Tolerance"))
        {
          sprintf(STR_char, "Feasibility Tolerance = %g", dval);
        }
      else if (!strcmp(this_name, "Hessian Rows"))
        {
          sprintf(STR_char, "Hessian Rows = %d", ival);
        }
      else if (!strcmp(this_name, "Infinite Bound Size"))
        {
          sprintf(STR_char, "Infinite Bound Size = %g", dval);
        }
      else if (!strcmp(this_name, "Infinite Step Size"))
        {
          sprintf(STR_char, "Infinite Step Size = %g", dval);
        }
      else if (!strcmp(this_name, "Iteration Limit"))
        {
          sprintf(STR_char, "Iteration Limit = %d", ival);
        }
      else if (!strcmp(this_name, "Maximum Degrees of Freedom"))
        {
          sprintf(STR_char, "Maximum Degrees of Freedom = %d", ival);
        }
      else if (!strcmp(this_name, "Monitoring File")) /* Can't have mode 0 as this is reading mode only */
        {
          if (mode == 0) mode = 1;
          /* Use unit_num 7 by default */
          if (unit_num == 0) unit_num = 7;
          /* Open up a file for output (either write or append) */
          Integer IFAIL_write_integer = 1;

          x04acf_(&unit_num,
                  strncpy(STR_char, CHAR(STRING_ELT(tentry,
                                                    0)),
                          100), &mode, &IFAIL_write_integer, 100);
          if (IFAIL_write_integer != 0)
            {
              unit_num = -1;
              break;
            }
          sprintf(STR_char, "monitoring file = %d", unit_num);
        }
      else if (!strcmp(this_name, "Optimality Tolerance"))
        {
          sprintf(STR_char, "Optimality Tolerance = %g", dval);
        }
      else if (!strcmp(this_name, "Print Level"))
        {
          sprintf(STR_char, "Print Level = %d", ival);
        }
      else if (!strcmp(this_name, "Rank Tolerance"))
        {
          sprintf(STR_char, "Rank Tolerance = %g", dval);
        }

      /* All other options are ignored (this includes the valid ones: cold start and warm start) */

      UNPROTECT(1);

      /* Call the option setting routine */
      if (STR_char[0])
        {
          INFORM_setter_integer = 1;
          STR_length = strlen(STR_char);
          e04nha_(STR_char, LWSAV_logicalArray, IWSAV_integerMatrix,
                  RWSAV_doubleMatrix, &INFORM_setter_integer,
                  STR_length);

          if (INFORM_setter_integer != 0)
            {
              sprintf(err_msg, "E04NHA failed with IFAIL = %ld\n",
                      (long) INFORM_setter_integer);
              error(err_msg);
            }
        }
    }
  UNPROTECT(1);
  return unit_num;
}

void E04NFA_clean_up(double *A, double *BL, double *BU, double *CVEC,
                     double *H, Integer *ISTATE, double *X, double *AX,
                     double *CLAMDA,
                     Integer *IWORK, double *WORK, Integer *LWSAV,
                     Integer *IWSAV,
                     double *RWSAV)
{
  if (A) free(A);
  if (BL) free(BL);
  if (BU) free(BU);
  if (CVEC) free(CVEC);
  if (H) free(H);
  if (ISTATE) free(ISTATE);
  if (X) free(X);
  if (AX) free(AX);
  if (CLAMDA) free(CLAMDA);
  if (IWORK) free(IWORK);
  if (WORK) free(WORK);
  if (LWSAV) free(LWSAV);
  if (IWSAV) free(IWSAV);
  if (RWSAV) free(RWSAV);
  return;
}
