
#include <R.h>
#include <Rinternals.h>
#include "nag_rwrapper_utils.h"
#include "nagmk23.h"
#ifdef __cplusplus
extern "C" {
#endif

#ifdef __cplusplus
}
#endif
int wE04UFF_handle_options(SEXP OPTLIST, Integer LWSAV_logicalArray[],
                           Integer IWSAV_integerMatrix[],
                           double RWSAV_doubleMatrix[])
;

/* Length of array to hold error messages, no checks are made to ensure this is large enough */
#define LEN_ERR_MSG 100

void E04UFA_clean_up(double *A, double *BL, double *BU, Integer *ISTATE,
                     double *C, double *CJAC, double *CLAMDA, double *OBJGRD,
                     double *R, double *X,
                     Integer *NEEDC, Integer *IWORK, double *WORK, char *CWSAV,
                     Integer *LWSAV,
                     Integer *IWSAV,
                     double *RWSAV);

SEXP WE04UFF(SEXP IREVCM, SEXP N, SEXP NCLIN, SEXP NCNLN, SEXP A, SEXP BL,
             SEXP BU, SEXP ITER, SEXP ISTATE, SEXP C, SEXP CJAC, SEXP CLAMDA,
             SEXP OBJF,
             SEXP OBJGRD, SEXP R, SEXP X, SEXP IWORK, SEXP WORK, SEXP CWSAV,
             SEXP LWSAV,
             SEXP IWSAV, SEXP RWSAV,
             SEXP OPTLIST)
{
  Integer IFAIL_integer, IFAIL_EXTRACTION_integer;
  SEXP    ans, names;
  Integer nadv, iflag;

/*Initialization for the reverse communication parameter*/
  int     IREVCM_integer;
  if (nag_extractInteger(IREVCM, &IREVCM_integer))
    {
      error("Integer extraction error for %s", "IREVCM");
    }

  /* Initialize the option arrays */
  Integer IFAIL_initializer_integer = 1;
  char    err_msg[LEN_ERR_MSG];
  char    RNAME_char[6] = "E04UFA";
  Integer RNAME_length = 6;

/*Declare dimension variables for option initializer*/
  Integer LCWSAV_integer;
  if ((strcmp(RNAME_char,
              "E04UFF") == 0) || (strcmp(RNAME_char, "E04UFA") == 0))
    {
      LCWSAV_integer = 5;
    }
  else
    {
      LCWSAV_integer = 1;
    }

  Integer LLWSAV_integer;
  if ((strcmp(RNAME_char,
              "E04NKF") == 0) || (strcmp(RNAME_char, "E04NKA") == 0))
    {
      LLWSAV_integer = 20;
    }
  else
    {
      if ((strcmp(RNAME_char,
                  "E04UGF") == 0) || (strcmp(RNAME_char, "E04UGA") == 0))
        {
          LLWSAV_integer = 20;
        }
      else
        {
          LLWSAV_integer = 120;
        }
    }

  Integer LIWSAV_integer;
  if ((strcmp(RNAME_char,
              "E04NKF") == 0) || (strcmp(RNAME_char, "E04NKA") == 0))
    {
      LIWSAV_integer = 380;
    }
  else
    {
      if ((strcmp(RNAME_char,
                  "E04UGF") == 0) || (strcmp(RNAME_char, "E04UGA") == 0))
        {
          LIWSAV_integer = 550;
        }
      else
        {
          LIWSAV_integer = 610;
        }
    }

  Integer LRWSAV_integer;
  if ((strcmp(RNAME_char,
              "E04NKF") == 0) || (strcmp(RNAME_char, "E04NKA") == 0))
    {
      LRWSAV_integer = 285;
    }
  else
    {
      if ((strcmp(RNAME_char,
                  "E04UGF") == 0) || (strcmp(RNAME_char, "E04UGA") == 0))
        {
          LRWSAV_integer = 550;
        }
      else
        {
          LRWSAV_integer = 475;
        }
    }

/*Declare the parameters for the option initializer*/
  char    *CWSAV_charArray = 0;
  Integer *LWSAV_logicalArray = 0;
  Integer *IWSAV_integerMatrix = 0;
  double  *RWSAV_doubleMatrix = 0;
  Integer CWSAV_dim1 = LCWSAV_integer;
  if (!(CWSAV_charArray = (char *) malloc(CWSAV_dim1*80*sizeof(char))))
    {
      error("Memory allocation error for %s", "CWSAV");
    }
  Integer LWSAV_dim1 = LLWSAV_integer;
  if (!(LWSAV_logicalArray = (Integer *) malloc(LWSAV_dim1*sizeof(Integer))))
    {
      error("Memory allocation error for %s", "LWSAV");
    }
  Integer IWSAV_dim1 = LIWSAV_integer;
  if (!(IWSAV_integerMatrix = (Integer *) malloc(IWSAV_dim1*sizeof(Integer))))
    {
      error("Memory allocation error for %s", "IWSAV");
    }
  Integer RWSAV_dim1 = LRWSAV_integer;
  if (!(RWSAV_doubleMatrix = (double *) malloc(RWSAV_dim1*sizeof(double))))
    {
      error("Memory allocation error for %s", "RWSAV");
    }

/*Extract the variable from the input except on the first run*/
  if (IREVCM_integer > 0)
    {
      if ((IFAIL_EXTRACTION_integer =
             nag_extractCharVector(CWSAV_dim1, CWSAV, CWSAV_charArray, 80)))
        {
          if ((IFAIL_EXTRACTION_integer == 3) ||
              (IFAIL_EXTRACTION_integer == 4))
            {
              warning(
                "Dimensions mismatch for %s, matrix is of size %d and the expected size is %d",
                "CWSAV", nrows(CWSAV), CWSAV_dim1);
            }
          else
            {
              error("Array extraction error for %s", "CWSAV");
            }
        }
      if ((IFAIL_EXTRACTION_integer =
             nag_extractLogicalVector(LWSAV_dim1, LWSAV, LWSAV_logicalArray)))
        {
          if ((IFAIL_EXTRACTION_integer == 3) ||
              (IFAIL_EXTRACTION_integer == 4))
            {
              warning(
                "Dimensions mismatch for %s, matrix is of size %d and the expected size is %d",
                "LWSAV", nrows(LWSAV), LWSAV_dim1);
            }
          else
            {
              error("Array extraction error for %s", "LWSAV");
            }
        }
      if ((IFAIL_EXTRACTION_integer =
             nag_extractIntegerMatrix(1, IWSAV_dim1, 1, IWSAV,
                                      IWSAV_integerMatrix)))
        {
          if ((IFAIL_EXTRACTION_integer == 3) ||
              (IFAIL_EXTRACTION_integer == 4))
            {
              warning(
                "Dimensions mismatch for %s, matrix is of size %d and the expected size is %d",
                "IWSAV", nrows(IWSAV), IWSAV_dim1);
            }
          else
            {
              error("Array extraction error for %s", "IWSAV");
            }
        }
      if ((IFAIL_EXTRACTION_integer =
             nag_extractDoubleMatrix(1, RWSAV_dim1, 1, RWSAV,
                                     RWSAV_doubleMatrix)))
        {
          if ((IFAIL_EXTRACTION_integer == 3) ||
              (IFAIL_EXTRACTION_integer == 4))
            {
              warning(
                "Dimensions mismatch for %s, matrix is of size %d and the expected size is %d",
                "RWSAV", nrows(RWSAV), RWSAV_dim1);
            }
          else
            {
              error("Array extraction error for %s", "RWSAV");
            }
        }
    }
  else
    {
      nag_initializeIntegerMatrix(IWSAV_dim1, 1, IWSAV_integerMatrix);
      nag_initializeDoubleMatrix(RWSAV_dim1, 1, RWSAV_doubleMatrix);
      e04wbf_(RNAME_char, CWSAV_charArray, &LCWSAV_integer, LWSAV_logicalArray,
              &LLWSAV_integer, IWSAV_integerMatrix, &LIWSAV_integer,
              RWSAV_doubleMatrix,
              &LRWSAV_integer, &IFAIL_initializer_integer, RNAME_length,
              80);

      if (IFAIL_initializer_integer != 0)
        {
          sprintf(err_msg, "E04WBF failed with IFAIL = %ld\n",
                  (long) IFAIL_initializer_integer);
          error(err_msg);
        }
    }
/* Handle options */
  int unit_num;

  unit_num =
    wE04UFF_handle_options(OPTLIST, LWSAV_logicalArray, IWSAV_integerMatrix,
                           RWSAV_doubleMatrix);
  if (unit_num < 0)
    {
      /* Error opening output file */
      sprintf(
        err_msg,
        "Error opening monitoring file for output, check value for `monitoring file` entry in `optlist`");
      error(err_msg);
    }
  else if (unit_num > 0)
    {
      /* We are using an output file, so need to handle the advisory channel */

      /* Remember the current value */
      iflag = 0;
      x04abf_(&iflag, &nadv);

      /* Set the advisory channel to the output file. Need to do this, otherwise E04UFF sends output to both the
         advisory channel and the output file */
      iflag = 1;
      x04abf_(&iflag, &unit_num);
    }

/*initialization for input variables*/
  int     N_integer;
  if (nag_extractInteger(N, &N_integer))
    {
      error("Integer extraction error for %s", "N");
    }
  int     NCLIN_integer;
  if (nag_extractInteger(NCLIN, &NCLIN_integer))
    {
      error("Integer extraction error for %s", "NCLIN");
    }
  int     NCNLN_integer;
  if (nag_extractInteger(NCNLN, &NCNLN_integer))
    {
      error("Integer extraction error for %s", "NCNLN");
    }
  double  *A_doubleMatrix = 0;
  double  *BL_doubleMatrix = 0;
  double  *BU_doubleMatrix = 0;
  int     ITER_integer;
  if (nag_extractInteger(ITER, &ITER_integer))
    {
      error("Integer extraction error for %s", "ITER");
    }
  Integer *ISTATE_integerMatrix = 0;
  double  *C_doubleMatrix = 0;
  double  *CJAC_doubleMatrix = 0;
  double  *CLAMDA_doubleMatrix = 0;
  double  OBJF_double;
  if (nag_extractDouble(OBJF, &OBJF_double))
    {
      error("Double extraction error for %s", "OBJF");
    }
  double  *OBJGRD_doubleMatrix = 0;
  double  *R_doubleMatrix = 0;
  double  *X_doubleMatrix = 0;

/*initialization for dimension variables*/
  Integer LDA_integer = MAX(1, NCLIN_integer);
  Integer LDCJ_integer = MAX(1, NCNLN_integer);
  Integer LDR_integer = N_integer;
  Integer LIWORK_integer = 3*N_integer+NCLIN_integer+2*NCNLN_integer;
  Integer LWORK_integer;
  if (NCNLN_integer == 0 && NCLIN_integer == 0)
    {
      LWORK_integer = 21*N_integer+2;
    }
  else
    {
      if (NCNLN_integer == 0 && NCLIN_integer > 0)
        {
          LWORK_integer = 2*pow(N_integer, 2)+21*N_integer+11*NCLIN_integer+2;
        }
      else
        {
          if (NCNLN_integer > 0 && NCLIN_integer >= 0)
            {
              LWORK_integer = 2*
                              pow(N_integer,
                                  2)+N_integer*NCLIN_integer+2*N_integer*
                              NCNLN_integer+21*N_integer+11*
                              NCLIN_integer+22*NCNLN_integer+1;
            }
        }
    }

/*initialization for output variables*/
  Integer *NEEDC_integerMatrix = 0;

/*allocation general variables*/
  Integer A_dim1 = LDA_integer;
  Integer A_dim2;
  if ((NCLIN_integer > 0))
    {
      A_dim2 = N_integer;
    }
  else
    {
      A_dim2 = 1;
    }
  if (!(A_doubleMatrix = (double *) malloc(A_dim1*A_dim2*sizeof(double))))
    {
      error("Memory allocation error for %s", "A");
    }
  Integer BL_dim1 = N_integer+NCLIN_integer+NCNLN_integer;
  if (!(BL_doubleMatrix = (double *) malloc(BL_dim1*sizeof(double))))
    {
      error("Memory allocation error for %s", "BL");
    }
  Integer BU_dim1 = N_integer+NCLIN_integer+NCNLN_integer;
  if (!(BU_doubleMatrix = (double *) malloc(BU_dim1*sizeof(double))))
    {
      error("Memory allocation error for %s", "BU");
    }
  Integer ISTATE_dim1 = N_integer+NCLIN_integer+NCNLN_integer;
  if (!(ISTATE_integerMatrix = (Integer *) malloc(ISTATE_dim1*sizeof(Integer))))
    {
      error("Memory allocation error for %s", "ISTATE");
    }
  Integer C_dim1 = MAX(1, NCNLN_integer);
  if (!(C_doubleMatrix = (double *) malloc(C_dim1*sizeof(double))))
    {
      error("Memory allocation error for %s", "C");
    }
  Integer CJAC_dim1 = LDCJ_integer;
  Integer CJAC_dim2;
  if (NCNLN_integer > 0)
    {
      CJAC_dim2 = N_integer;
    }
  else
    {
      CJAC_dim2 = 1;
    }
  if (!(CJAC_doubleMatrix =
          (double *) malloc(CJAC_dim1*CJAC_dim2*sizeof(double))))
    {
      error("Memory allocation error for %s", "CJAC");
    }
  Integer CLAMDA_dim1 = N_integer+NCLIN_integer+NCNLN_integer;
  if (!(CLAMDA_doubleMatrix = (double *) malloc(CLAMDA_dim1*sizeof(double))))
    {
      error("Memory allocation error for %s", "CLAMDA");
    }
  Integer OBJGRD_dim1 = N_integer;
  if (!(OBJGRD_doubleMatrix = (double *) malloc(OBJGRD_dim1*sizeof(double))))
    {
      error("Memory allocation error for %s", "OBJGRD");
    }
  Integer R_dim1 = LDR_integer;
  Integer R_dim2 = N_integer;
  if (!(R_doubleMatrix = (double *) malloc(R_dim1*R_dim2*sizeof(double))))
    {
      error("Memory allocation error for %s", "R");
    }
  Integer X_dim1 = N_integer;
  if (!(X_doubleMatrix = (double *) malloc(X_dim1*sizeof(double))))
    {
      error("Memory allocation error for %s", "X");
    }
  Integer NEEDC_dim1 = MAX(1, NCNLN_integer);
  if (!(NEEDC_integerMatrix = (Integer *) malloc(NEEDC_dim1*sizeof(Integer))))
    {
      error("Memory allocation error for %s", "NEEDC");
    }

/*initialization for communication variables*/
  Integer *IWORK_integerMatrix = 0;
  double  *WORK_doubleMatrix = 0;

/*allocation communication variables*/
  Integer IWORK_dim1 = LIWORK_integer;
  if (!(IWORK_integerMatrix = (Integer *) malloc(IWORK_dim1*sizeof(Integer))))
    {
      error("Memory allocation error for %s", "IWORK");
    }
  Integer WORK_dim1 = LWORK_integer;
  if (!(WORK_doubleMatrix = (double *) malloc(WORK_dim1*sizeof(double))))
    {
      error("Memory allocation error for %s", "WORK");
    }

/*allocation for dimension variables*/

/*extraction for input variables*/
  if ((IFAIL_EXTRACTION_integer =
         nag_extractDoubleMatrix(1, A_dim1, A_dim2, A, A_doubleMatrix)))
    {
      if ((IFAIL_EXTRACTION_integer == 3) || (IFAIL_EXTRACTION_integer == 4))
        {
          warning(
            "Dimensions mismatch for %s, matrix is of size %d and the expected size is %d",
            "A", nrows(A), A_dim1);
        }
      else
        {
          E04UFA_clean_up(A_doubleMatrix, BL_doubleMatrix, BU_doubleMatrix,
                          ISTATE_integerMatrix, C_doubleMatrix,
                          CJAC_doubleMatrix,
                          CLAMDA_doubleMatrix, OBJGRD_doubleMatrix,
                          R_doubleMatrix, X_doubleMatrix,
                          NEEDC_integerMatrix, IWORK_integerMatrix,
                          WORK_doubleMatrix,
                          CWSAV_charArray, LWSAV_logicalArray,
                          IWSAV_integerMatrix,
                          RWSAV_doubleMatrix);
          error("Array extraction error for %s", "A");
        }
    }
  if ((IFAIL_EXTRACTION_integer =
         nag_extractDoubleMatrix(1, BL_dim1, 1, BL, BL_doubleMatrix)))
    {
      if ((IFAIL_EXTRACTION_integer == 3) || (IFAIL_EXTRACTION_integer == 4))
        {
          warning(
            "Dimensions mismatch for %s, matrix is of size %d and the expected size is %d",
            "BL", nrows(BL), BL_dim1);
        }
      else
        {
          E04UFA_clean_up(A_doubleMatrix, BL_doubleMatrix, BU_doubleMatrix,
                          ISTATE_integerMatrix, C_doubleMatrix,
                          CJAC_doubleMatrix,
                          CLAMDA_doubleMatrix, OBJGRD_doubleMatrix,
                          R_doubleMatrix, X_doubleMatrix,
                          NEEDC_integerMatrix, IWORK_integerMatrix,
                          WORK_doubleMatrix,
                          CWSAV_charArray, LWSAV_logicalArray,
                          IWSAV_integerMatrix,
                          RWSAV_doubleMatrix);
          error("Array extraction error for %s", "BL");
        }
    }
  if ((IFAIL_EXTRACTION_integer =
         nag_extractDoubleMatrix(1, BU_dim1, 1, BU, BU_doubleMatrix)))
    {
      if ((IFAIL_EXTRACTION_integer == 3) || (IFAIL_EXTRACTION_integer == 4))
        {
          warning(
            "Dimensions mismatch for %s, matrix is of size %d and the expected size is %d",
            "BU", nrows(BU), BU_dim1);
        }
      else
        {
          E04UFA_clean_up(A_doubleMatrix, BL_doubleMatrix, BU_doubleMatrix,
                          ISTATE_integerMatrix, C_doubleMatrix,
                          CJAC_doubleMatrix,
                          CLAMDA_doubleMatrix, OBJGRD_doubleMatrix,
                          R_doubleMatrix, X_doubleMatrix,
                          NEEDC_integerMatrix, IWORK_integerMatrix,
                          WORK_doubleMatrix,
                          CWSAV_charArray, LWSAV_logicalArray,
                          IWSAV_integerMatrix,
                          RWSAV_doubleMatrix);
          error("Array extraction error for %s", "BU");
        }
    }
  if ((IFAIL_EXTRACTION_integer =
         nag_extractIntegerMatrix(1, ISTATE_dim1, 1, ISTATE,
                                  ISTATE_integerMatrix)))
    {
      if ((IFAIL_EXTRACTION_integer == 3) || (IFAIL_EXTRACTION_integer == 4))
        {
          warning(
            "Dimensions mismatch for %s, matrix is of size %d and the expected size is %d",
            "ISTATE", nrows(ISTATE), ISTATE_dim1);
        }
      else
        {
          E04UFA_clean_up(A_doubleMatrix, BL_doubleMatrix, BU_doubleMatrix,
                          ISTATE_integerMatrix, C_doubleMatrix,
                          CJAC_doubleMatrix,
                          CLAMDA_doubleMatrix, OBJGRD_doubleMatrix,
                          R_doubleMatrix, X_doubleMatrix,
                          NEEDC_integerMatrix, IWORK_integerMatrix,
                          WORK_doubleMatrix,
                          CWSAV_charArray, LWSAV_logicalArray,
                          IWSAV_integerMatrix,
                          RWSAV_doubleMatrix);
          error("Array extraction error for %s", "ISTATE");
        }
    }
  if ((IFAIL_EXTRACTION_integer =
         nag_extractDoubleMatrix(1, C_dim1, 1, C, C_doubleMatrix)))
    {
      if ((IFAIL_EXTRACTION_integer == 3) || (IFAIL_EXTRACTION_integer == 4))
        {
          warning(
            "Dimensions mismatch for %s, matrix is of size %d and the expected size is %d",
            "C", nrows(C), C_dim1);
        }
      else
        {
          E04UFA_clean_up(A_doubleMatrix, BL_doubleMatrix, BU_doubleMatrix,
                          ISTATE_integerMatrix, C_doubleMatrix,
                          CJAC_doubleMatrix,
                          CLAMDA_doubleMatrix, OBJGRD_doubleMatrix,
                          R_doubleMatrix, X_doubleMatrix,
                          NEEDC_integerMatrix, IWORK_integerMatrix,
                          WORK_doubleMatrix,
                          CWSAV_charArray, LWSAV_logicalArray,
                          IWSAV_integerMatrix,
                          RWSAV_doubleMatrix);
          error("Array extraction error for %s", "C");
        }
    }
  if ((IFAIL_EXTRACTION_integer =
         nag_extractDoubleMatrix(1, CJAC_dim1, CJAC_dim2, CJAC,
                                 CJAC_doubleMatrix)))
    {
      if ((IFAIL_EXTRACTION_integer == 3) || (IFAIL_EXTRACTION_integer == 4))
        {
          warning(
            "Dimensions mismatch for %s, matrix is of size %d and the expected size is %d",
            "CJAC", nrows(CJAC), CJAC_dim1);
        }
      else
        {
          E04UFA_clean_up(A_doubleMatrix, BL_doubleMatrix, BU_doubleMatrix,
                          ISTATE_integerMatrix, C_doubleMatrix,
                          CJAC_doubleMatrix,
                          CLAMDA_doubleMatrix, OBJGRD_doubleMatrix,
                          R_doubleMatrix, X_doubleMatrix,
                          NEEDC_integerMatrix, IWORK_integerMatrix,
                          WORK_doubleMatrix,
                          CWSAV_charArray, LWSAV_logicalArray,
                          IWSAV_integerMatrix,
                          RWSAV_doubleMatrix);
          error("Array extraction error for %s", "CJAC");
        }
    }
  if ((IFAIL_EXTRACTION_integer =
         nag_extractDoubleMatrix(1, CLAMDA_dim1, 1, CLAMDA,
                                 CLAMDA_doubleMatrix)))
    {
      if ((IFAIL_EXTRACTION_integer == 3) || (IFAIL_EXTRACTION_integer == 4))
        {
          warning(
            "Dimensions mismatch for %s, matrix is of size %d and the expected size is %d",
            "CLAMDA", nrows(CLAMDA), CLAMDA_dim1);
        }
      else
        {
          E04UFA_clean_up(A_doubleMatrix, BL_doubleMatrix, BU_doubleMatrix,
                          ISTATE_integerMatrix, C_doubleMatrix,
                          CJAC_doubleMatrix,
                          CLAMDA_doubleMatrix, OBJGRD_doubleMatrix,
                          R_doubleMatrix, X_doubleMatrix,
                          NEEDC_integerMatrix, IWORK_integerMatrix,
                          WORK_doubleMatrix,
                          CWSAV_charArray, LWSAV_logicalArray,
                          IWSAV_integerMatrix,
                          RWSAV_doubleMatrix);
          error("Array extraction error for %s", "CLAMDA");
        }
    }
  if ((IFAIL_EXTRACTION_integer =
         nag_extractDoubleMatrix(1, OBJGRD_dim1, 1, OBJGRD,
                                 OBJGRD_doubleMatrix)))
    {
      if ((IFAIL_EXTRACTION_integer == 3) || (IFAIL_EXTRACTION_integer == 4))
        {
          warning(
            "Dimensions mismatch for %s, matrix is of size %d and the expected size is %d",
            "OBJGRD", nrows(OBJGRD), OBJGRD_dim1);
        }
      else
        {
          E04UFA_clean_up(A_doubleMatrix, BL_doubleMatrix, BU_doubleMatrix,
                          ISTATE_integerMatrix, C_doubleMatrix,
                          CJAC_doubleMatrix,
                          CLAMDA_doubleMatrix, OBJGRD_doubleMatrix,
                          R_doubleMatrix, X_doubleMatrix,
                          NEEDC_integerMatrix, IWORK_integerMatrix,
                          WORK_doubleMatrix,
                          CWSAV_charArray, LWSAV_logicalArray,
                          IWSAV_integerMatrix,
                          RWSAV_doubleMatrix);
          error("Array extraction error for %s", "OBJGRD");
        }
    }
  if ((IFAIL_EXTRACTION_integer =
         nag_extractDoubleMatrix(1, R_dim1, R_dim2, R, R_doubleMatrix)))
    {
      if ((IFAIL_EXTRACTION_integer == 3) || (IFAIL_EXTRACTION_integer == 4))
        {
          warning(
            "Dimensions mismatch for %s, matrix is of size %d and the expected size is %d",
            "R", nrows(R), R_dim1);
        }
      else
        {
          E04UFA_clean_up(A_doubleMatrix, BL_doubleMatrix, BU_doubleMatrix,
                          ISTATE_integerMatrix, C_doubleMatrix,
                          CJAC_doubleMatrix,
                          CLAMDA_doubleMatrix, OBJGRD_doubleMatrix,
                          R_doubleMatrix, X_doubleMatrix,
                          NEEDC_integerMatrix, IWORK_integerMatrix,
                          WORK_doubleMatrix,
                          CWSAV_charArray, LWSAV_logicalArray,
                          IWSAV_integerMatrix,
                          RWSAV_doubleMatrix);
          error("Array extraction error for %s", "R");
        }
    }
  if ((IFAIL_EXTRACTION_integer =
         nag_extractDoubleMatrix(1, X_dim1, 1, X, X_doubleMatrix)))
    {
      if ((IFAIL_EXTRACTION_integer == 3) || (IFAIL_EXTRACTION_integer == 4))
        {
          warning(
            "Dimensions mismatch for %s, matrix is of size %d and the expected size is %d",
            "X", nrows(X), X_dim1);
        }
      else
        {
          E04UFA_clean_up(A_doubleMatrix, BL_doubleMatrix, BU_doubleMatrix,
                          ISTATE_integerMatrix, C_doubleMatrix,
                          CJAC_doubleMatrix,
                          CLAMDA_doubleMatrix, OBJGRD_doubleMatrix,
                          R_doubleMatrix, X_doubleMatrix,
                          NEEDC_integerMatrix, IWORK_integerMatrix,
                          WORK_doubleMatrix,
                          CWSAV_charArray, LWSAV_logicalArray,
                          IWSAV_integerMatrix,
                          RWSAV_doubleMatrix);
          error("Array extraction error for %s", "X");
        }
    }
  if ((IFAIL_EXTRACTION_integer =
         nag_extractIntegerMatrix(1, IWORK_dim1, 1, IWORK, IWORK_integerMatrix)))
    {
      if ((IFAIL_EXTRACTION_integer == 3) || (IFAIL_EXTRACTION_integer == 4))
        {
          warning(
            "Dimensions mismatch for %s, matrix is of size %d and the expected size is %d",
            "IWORK", nrows(IWORK), IWORK_dim1);
        }
      else
        {
          E04UFA_clean_up(A_doubleMatrix, BL_doubleMatrix, BU_doubleMatrix,
                          ISTATE_integerMatrix, C_doubleMatrix,
                          CJAC_doubleMatrix,
                          CLAMDA_doubleMatrix, OBJGRD_doubleMatrix,
                          R_doubleMatrix, X_doubleMatrix,
                          NEEDC_integerMatrix, IWORK_integerMatrix,
                          WORK_doubleMatrix,
                          CWSAV_charArray, LWSAV_logicalArray,
                          IWSAV_integerMatrix,
                          RWSAV_doubleMatrix);
          error("Array extraction error for %s", "IWORK");
        }
    }
  if ((IFAIL_EXTRACTION_integer =
         nag_extractDoubleMatrix(1, WORK_dim1, 1, WORK, WORK_doubleMatrix)))
    {
      if ((IFAIL_EXTRACTION_integer == 3) || (IFAIL_EXTRACTION_integer == 4))
        {
          warning(
            "Dimensions mismatch for %s, matrix is of size %d and the expected size is %d",
            "WORK", nrows(WORK), WORK_dim1);
        }
      else
        {
          E04UFA_clean_up(A_doubleMatrix, BL_doubleMatrix, BU_doubleMatrix,
                          ISTATE_integerMatrix, C_doubleMatrix,
                          CJAC_doubleMatrix,
                          CLAMDA_doubleMatrix, OBJGRD_doubleMatrix,
                          R_doubleMatrix, X_doubleMatrix,
                          NEEDC_integerMatrix, IWORK_integerMatrix,
                          WORK_doubleMatrix,
                          CWSAV_charArray, LWSAV_logicalArray,
                          IWSAV_integerMatrix,
                          RWSAV_doubleMatrix);
          error("Array extraction error for %s", "WORK");
        }
    }

  /* Call the NAG routine */
  IFAIL_integer = 1;
  e04ufa_(&IREVCM_integer, &N_integer, &NCLIN_integer, &NCNLN_integer,
          &LDA_integer, &LDCJ_integer, &LDR_integer, A_doubleMatrix,
          BL_doubleMatrix,
          BU_doubleMatrix, &ITER_integer, ISTATE_integerMatrix, C_doubleMatrix,
          CJAC_doubleMatrix, CLAMDA_doubleMatrix, &OBJF_double,
          OBJGRD_doubleMatrix,
          R_doubleMatrix, X_doubleMatrix, NEEDC_integerMatrix,
          IWORK_integerMatrix,
          &LIWORK_integer, WORK_doubleMatrix, &LWORK_integer, CWSAV_charArray,
          LWSAV_logicalArray, IWSAV_integerMatrix, RWSAV_doubleMatrix,
          &IFAIL_integer,
          80);

  /* Close the monitoring file if one opened */

  if (unit_num > 0)
    {
      IFAIL_integer = 1;
      x04adf_(&unit_num, &IFAIL_integer);

      /* Set the advisory channel back to its previous value */
      iflag = 1;
      x04abf_(&iflag, &nadv);
    }

  /* Error returns from NAG routine */
  if (IFAIL_integer != 0 && IREVCM_integer == 0)
    {
      warning(
        "ABNORMAL EXIT from NAG library routine  E04UFF, : IFAIL = %ld\n",
        (long) IFAIL_integer);
    }

/* Get the list of results */
  PROTECT(ans = allocVector(VECSXP, 18));
  SET_VECTOR_ELT(ans, 0, nag_i2r(1, &IREVCM_integer));
  SET_VECTOR_ELT(ans, 1, nag_i2r(1, &ITER_integer));
  SET_VECTOR_ELT(ans, 2, nag_mi2r(1, ISTATE_dim1, 1, ISTATE_integerMatrix));
  SET_VECTOR_ELT(ans, 3, nag_md2r(1, C_dim1, 1, C_doubleMatrix));
  SET_VECTOR_ELT(ans, 4, nag_md2r(1, CJAC_dim1, CJAC_dim2, CJAC_doubleMatrix));
  SET_VECTOR_ELT(ans, 5, nag_md2r(1, CLAMDA_dim1, 1, CLAMDA_doubleMatrix));
  SET_VECTOR_ELT(ans, 6, nag_d2r(1, &OBJF_double));
  SET_VECTOR_ELT(ans, 7, nag_md2r(1, OBJGRD_dim1, 1, OBJGRD_doubleMatrix));
  SET_VECTOR_ELT(ans, 8, nag_md2r(1, R_dim1, R_dim2, R_doubleMatrix));
  SET_VECTOR_ELT(ans, 9, nag_md2r(1, X_dim1, 1, X_doubleMatrix));
  SET_VECTOR_ELT(ans, 10, nag_mi2r(1, NEEDC_dim1, 1, NEEDC_integerMatrix));
  SET_VECTOR_ELT(ans, 11, nag_mi2r(1, IWORK_dim1, 1, IWORK_integerMatrix));
  SET_VECTOR_ELT(ans, 12, nag_md2r(1, WORK_dim1, 1, WORK_doubleMatrix));
  SET_VECTOR_ELT(ans, 13, nag_c2r(CWSAV_dim1, 80, 1, CWSAV_charArray));
  SET_VECTOR_ELT(ans, 14, nag_l2r(LWSAV_dim1, LWSAV_logicalArray));
  SET_VECTOR_ELT(ans, 15, nag_mi2r(1, IWSAV_dim1, 1, IWSAV_integerMatrix));
  SET_VECTOR_ELT(ans, 16, nag_md2r(1, RWSAV_dim1, 1, RWSAV_doubleMatrix));
  SET_VECTOR_ELT(ans, 17, nag_i2r(1, &IFAIL_integer));
  /* Get names for the list of results */
  PROTECT(names = allocVector(STRSXP, 18));
  SET_STRING_ELT(names, 0, mkChar("IREVCM"));
  SET_STRING_ELT(names, 1, mkChar("ITER"));
  SET_STRING_ELT(names, 2, mkChar("ISTATE"));
  SET_STRING_ELT(names, 3, mkChar("C"));
  SET_STRING_ELT(names, 4, mkChar("CJAC"));
  SET_STRING_ELT(names, 5, mkChar("CLAMDA"));
  SET_STRING_ELT(names, 6, mkChar("OBJF"));
  SET_STRING_ELT(names, 7, mkChar("OBJGRD"));
  SET_STRING_ELT(names, 8, mkChar("R"));
  SET_STRING_ELT(names, 9, mkChar("X"));
  SET_STRING_ELT(names, 10, mkChar("NEEDC"));
  SET_STRING_ELT(names, 11, mkChar("IWORK"));
  SET_STRING_ELT(names, 12, mkChar("WORK"));
  SET_STRING_ELT(names, 13, mkChar("CWSAV"));
  SET_STRING_ELT(names, 14, mkChar("LWSAV"));
  SET_STRING_ELT(names, 15, mkChar("IWSAV"));
  SET_STRING_ELT(names, 16, mkChar("RWSAV"));
  SET_STRING_ELT(names, 17, mkChar("IFAIL"));
  setAttrib(ans, R_NamesSymbol, names);
/* Unprotect the ans and names objects */
  UNPROTECT(2);

/*Call the clean-up routine*/
  E04UFA_clean_up(A_doubleMatrix, BL_doubleMatrix, BU_doubleMatrix,
                  ISTATE_integerMatrix, C_doubleMatrix, CJAC_doubleMatrix,
                  CLAMDA_doubleMatrix,
                  OBJGRD_doubleMatrix, R_doubleMatrix, X_doubleMatrix,
                  NEEDC_integerMatrix,
                  IWORK_integerMatrix, WORK_doubleMatrix, CWSAV_charArray,
                  LWSAV_logicalArray,
                  IWSAV_integerMatrix,
                  RWSAV_doubleMatrix);

  return(ans);
}

int wE04UFF_handle_options(SEXP OPTLIST, Integer LWSAV_logicalArray[],
                           Integer IWSAV_integerMatrix[],
                           double RWSAV_doubleMatrix[])
{
  SEXP       names, tentry;
  char       err_msg[LEN_ERR_MSG];
  int        i, ival;
  Integer    INFORM_setter_integer, STR_length;
  double     dval;
  const char *this_name;
  char       STR_char[100];
  int        unit_num = 0, mode = 1;

  /* No options specified */
  if (!isNewList(OPTLIST))
    {
      return 0;
    }

  /* Get the list of names from the list */
  PROTECT(names = getAttrib(OPTLIST, R_NamesSymbol));
  for (i = 0; i < length(OPTLIST); i++)
    {
      this_name = CHAR(STRING_ELT(names, i));

      /* Only interested in the first element, which is what asReal should
         convert to a double */
      PROTECT(tentry = VECTOR_ELT(OPTLIST, i));
      if (!isString(tentry))
        {
          dval = asReal(tentry);
          if (!R_FINITE(dval)) dval = 0.0;
          ival = (int) dval;
        }
      else
        {
          dval = -1.0;
          ival = -1;
        }

      STR_char[0] = '\0';
      if (!strcmp(this_name, "list"))
        {
          if (ival)
            {
              sprintf(STR_char, "list");
            }
          else
            {
              sprintf(STR_char, "nolist");
            }
        }
      else if (!strcmp(this_name, "Central Difference Interval"))
        {
          sprintf(STR_char, "Central Difference Interval = %g", dval);
        }
      else if (!strcmp(this_name, "Crash Tolerance"))
        {
          sprintf(STR_char, "Crash Tolerance = %g", dval);
        }
      else if (!strcmp(this_name, "Derivative Level"))
        {
          sprintf(STR_char, "Derivative Level = %d", ival);
        }
      else if (!strcmp(this_name, "Difference Interval"))
        {
          sprintf(STR_char, "Difference Interval = %g", dval);
        }
      else if (!strcmp(this_name, "Feasibility Tolerance"))
        {
          sprintf(STR_char, "Feasibility Tolerance = %g", dval);
        }
      else if (!strcmp(this_name, "Function Precision"))
        {
          sprintf(STR_char, "Function Precision = %g", dval);
        }
      else if (!strcmp(this_name, "Infinite Bound Size"))
        {
          sprintf(STR_char, "Infinite Bound Size = %g", dval);
        }
      else if (!strcmp(this_name, "Infinite Step Size"))
        {
          sprintf(STR_char, "Infinite Step Size = %g", dval);
        }
      else if (!strcmp(this_name, "Line Search Tolerance"))
        {
          sprintf(STR_char, "Line Search Tolerance = %g", dval);
        }
      else if (!strcmp(this_name, "Major Iteration Limit"))
        {
          sprintf(STR_char, "Major Iteration Limit = %d", ival);
        }
      else if (!strcmp(this_name, "Major Print Level"))
        {
          sprintf(STR_char, "Major Print Level = %d", ival);
        }
      else if (!strcmp(this_name, "Major Print Level"))
        {
          sprintf(STR_char, "Major Print Level = %d", ival);
        }
      else if (!strcmp(this_name, "Minor Iteration Limit"))
        {
          sprintf(STR_char, "Minor Iteration Limit = %d", ival);
        }
      else if (!strcmp(this_name, "Minor Print Level"))
        {
          sprintf(STR_char, "Minor Print Level = %d", ival);
        }
      else if (!strcmp(this_name, "Monitoring File")) /* Can't have mode 0 as this is reading mode only */
        {
          if (mode == 0) mode = 1;
          /* Use unit_num 7 by default */
          if (unit_num == 0) unit_num = 7;
          /* Open up a file for output (either write or append) */
          Integer IFAIL_write_integer = 1;

          x04acf_(&unit_num,
                  strncpy(STR_char, CHAR(STRING_ELT(tentry,
                                                    0)),
                          100), &mode, &IFAIL_write_integer, 100);
          if (IFAIL_write_integer != 0)
            {
              unit_num = -1;
              break;
            }
          sprintf(STR_char, "monitoring file = %d", unit_num);
        }
      else if (!strcmp(this_name, "Optimality Tolerance"))
        {
          sprintf(STR_char, "Optimality Tolerance = %g", dval);
        }
      else if (!strcmp(this_name, "Step Limit"))
        {
          sprintf(STR_char, "Step Limit = %g", dval);
        }
      else if (!strcmp(this_name, "Verify Level"))
        {
          sprintf(STR_char, "Verify Level = %d", ival);
        }

      /* All other options are ignored (this includes the valid ones: cold start and warm start) */

      UNPROTECT(1);

      /* Call the option setting routine */
      if (STR_char[0])
        {
          INFORM_setter_integer = 1;
          STR_length = strlen(STR_char);
          e04uea_(STR_char, LWSAV_logicalArray, IWSAV_integerMatrix,
                  RWSAV_doubleMatrix, &INFORM_setter_integer,
                  STR_length);

          if (INFORM_setter_integer != 0)
            {
              sprintf(err_msg, "E04UEA failed with IFAIL = %ld\n",
                      (long) INFORM_setter_integer);
              error(err_msg);
            }
        }
    }
  UNPROTECT(1);
  return unit_num;
}

void E04UFA_clean_up(double *A, double *BL, double *BU, Integer *ISTATE,
                     double *C, double *CJAC, double *CLAMDA, double *OBJGRD,
                     double *R, double *X,
                     Integer *NEEDC, Integer *IWORK, double *WORK, char *CWSAV,
                     Integer *LWSAV,
                     Integer *IWSAV,
                     double *RWSAV)
{
  if (A) free(A);
  if (BL) free(BL);
  if (BU) free(BU);
  if (ISTATE) free(ISTATE);
  if (C) free(C);
  if (CJAC) free(CJAC);
  if (CLAMDA) free(CLAMDA);
  if (OBJGRD) free(OBJGRD);
  if (R) free(R);
  if (X) free(X);
  if (NEEDC) free(NEEDC);
  if (IWORK) free(IWORK);
  if (WORK) free(WORK);
  if (CWSAV) free(CWSAV);
  if (LWSAV) free(LWSAV);
  if (IWSAV) free(IWSAV);
  if (RWSAV) free(RWSAV);
  return;
}
